//+------------------------------------------------------------------+
//|                                                   Robot Danu.mq4 |
//|                      danusaputra  2012, Ultimate Explorer Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "danusaputra  2012, Ultimate Explorer Corp."
#property link      "http://www.metaquotes.net"

#define MAGICMA  20050610

#include <stdlib.mqh>

extern double lStopLoss          = 50;
extern double sStopLoss          = 50;
extern double lTakeProfit        = 100;
extern double sTakeProfit        = 100;
extern double lTrailingStop      = 10;
extern double sTrailingStop      = 10;
extern double Lots               = 0.5;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern int    Slippage           = 3;
extern double Period1            = 28;
extern double Period2            = 56;
extern double Period3            = 112;
extern string Dev_Step_1         ="3,9";
extern string Dev_Step_2         ="24,15";
extern string Dev_Step_3         ="63,36";
extern int    Symbol_1_Kod       =140;
extern int    Symbol_2_Kod       =141;
extern int    Symbol_3_Kod       =142;
extern bool   ShowAlerts         = false;

double pipMultiplier = 1;

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
{
    
    if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1; 
//---- check for history and trading
   
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
   
   if(lTrailingStop > 0) TrailingPositionsBuy();
   if(sTrailingStop > 0) TrailingPositionsSell();
return (0);
  }

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= Symbol() || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
{
   
   if (lStopLoss > 0)   double lbStop = Ask - lStopLoss   * Point * pipMultiplier; 
   else lbStop = 0;
   
   if (lTakeProfit > 0) double lbTake = Ask + lTakeProfit * Point * pipMultiplier;
   else lbTake = 0;
   
   if (sStopLoss > 0)   double lsStop = Bid + sStopLoss   * Point * pipMultiplier; 
   else lsStop = 0;
   
   if (sTakeProfit > 0) double lsTake = Bid - sTakeProfit * Point * pipMultiplier;
   else lsTake = 0;
   
   
   if(Volume[0]>1) return;
   

//---- get 3 Level ZZ Semafor
   
   double ZZ_1=iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,5,3);
   double ZZ_2=iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,4,3);
   

//---- sell conditions
   
   if(ZZ_1 > ZZ_2 && OP_SELL <= 3)  
   {
     int res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,Slippage*Point*pipMultiplier,lsStop,lsTake,"Robot Danu",MAGICMA,0,Red);
      
   return;
   }
     
//---- buy conditions
   if(ZZ_1 < ZZ_2 && OP_BUY <= 3)  
   {
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,Slippage*Point*pipMultiplier,lbStop,lbTake,"Robot Danu",MAGICMA,0,Blue);
      
   return;
   }

//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
  
void CheckForClose()  
{
   RefreshRates();
   double ZZ_1 = iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,5,3);
   double ZZ_2 = iCustom(Symbol(),0,"3_Level_ZZ_Semafor",Period1,Period2,Period3,Dev_Step_1,Dev_Step_2,Dev_Step_3,Symbol_1_Kod,Symbol_2_Kod,Symbol_3_Kod,4,3);
     
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGICMA)                       continue;
      if (OrderSymbol()     != Symbol())                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (ZZ_1 > ZZ_2)
        {
          bool buyClose = OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_BID),Slippage*pipMultiplier,Blue);
          if (buyClose == false)
          {
            int ErrorCode   = GetLastError();
            string ErrDesc  = ErrorDescription(ErrorCode);

            string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts  == true) Alert(ErrAlert);

            string ErrLog   = StringConcatenate("Bid: ",MarketInfo(Symbol(),MODE_BID)," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (ZZ_1 < ZZ_2)
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_ASK),Slippage*pipMultiplier,Red); 
          if (sellClose  == false)
          {
            ErrorCode = GetLastError();
            ErrDesc   = ErrorDescription(ErrorCode);

            ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts == true) Alert(ErrAlert);

            ErrLog   = StringConcatenate("Ask: ",MarketInfo(Symbol(),MODE_ASK)," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
   }
}
  
//
//
//
//
//

void TrailingPositionsBuy() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICMA) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > lTrailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() < Bid - lTrailingStop * Point * pipMultiplier) 
                      ModifyStopLoss(Bid    - lTrailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICMA) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > sTrailingStop * Point * pipMultiplier) { 
                  if (OrderStopLoss() > Ask + sTrailingStop * Point * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + sTrailingStop * Point * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(Symbol(),MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//


//+------------------------------------------------------------------+